# -*- coding: utf-8 -*-
#------------------------------------------------------------
# pelisalacarta - XBMC Plugin
# Helper para enlacespepito
# http://blog.tvalacarta.info/plugin-xbmc/pelisalacarta/
#------------------------------------------------------------
#
from core import scrapertools
from core import config
from core import logger
import os, sys, re
import hashlib
import base64

SERIES_PEPITO    = 0
PELICULAS_PEPITO = 1

ENLACESPEPITO_REQUEST_HEADERS = [
    ["User-Agent" , "Mozilla/5.0 (Windows NT 6.1; rv:28.0) Gecko/20100101 Firefox/28.0"],
    ["Accept-Encoding","gzip, deflate"],
    ["Accept-Language" , "es-ES,es;q=0.8,en-US;q=0.5,en;q=0.3"],
    ["Accept" , "text/html,application/xhtml+xml,application/xml;q=0.9,*/*;q=0.8"],
    ["Connection" , "keep-alive"]
]

def extract_link_from_cookies(CookiesPlain):

    Cookies = {}
    Urls = {}

#Vamos a Sacar Cookie a Cookie
    patron = '(.*?); domain=enlacespepito.com'
    matches = re.compile(patron,re.DOTALL).findall(CookiesPlain)

    for cookie in matches:
        #Quitamos la ', ' que sobra
        #logger.info("[seriespepito.py] Cookie a" + cookie)
        if cookie[0:2]==', ' :
            cookie = cookie[2:]

        #logger.info("[seriespepito.py] Cookie" + cookie)
        CookieVal = cookie.split(';')[0].split('=')[1].replace('%3D','=').replace('%2B','+')
        if CookieVal <> 'deleted' :
            cookieDecoded = base64.b64decode(CookieVal) #base64.b64decode(cookie.split(';')[0].split('=')[1].replace('%3D','=').replace('%2B','+'))
            #logger.info("[seriespepito.py] Cookie Decoded" + cookieDecoded)
            Cookies[cookie.split(';')[0].split('=')[0]] = cookieDecoded

#Ya tenemos un diccionario (Cookies) con las Cookies con su valor decodificados ahora a procesarlas

    for cookie, cookieval in Cookies.iteritems():
        #Buscar esta cookie
        #'<script>a8e7=$.cookie("535a7c81cffa4008d4ad2afd83c93a6d").split(",");$("."+a8e7[2]).show();'
        #logger.info("[seriespepito.py] cookie : " + cookie)
        #logger.info("[seriespepito.py] cookieval : " + cookieval)
        patron = '<script>.*?=\$.cookie\("([^"]+)"\)\.split\("([^"]+)"\);\$\(.*?\[(.*?)\]\)\.show\(\);'
        matches = re.compile(patron,re.DOTALL).findall(cookieval)
        for CookieIndex, CharSplit, IndexSplit in matches:
            logger.info("[seriespepito.py] Encontrado " + CookieIndex + '-' + CharSplit + '-' + IndexSplit )

        #Buscar esta cookie
        #<script>d6k2=["l90390f8fbe8ed11edf786311d303f31a","ba01e49b621dfa0e7a78b97bd4b452585","j99dbdc98c46df1ea12f3eed985858cfa"];n5m5=["16668c6ecc64661408b8c1ce61c66884/0d8bed30n06400ebf668c686f68b6n1dbee3fd8bf664d3f8416c6e0066b38c131","16266g2ygg24261406b6g4gy61g29664/0d6byd60a06400ybf296g662f66b6a4dbyy6fd6bf264d6f6416g6y0069b66g461","13237g2egg24231404b7g5ge31g29744/0d7bed30a03400ebn297g342n37b3a5dbee3nd7bn234d3n7413g3e0039b34g531"];for(
        patron = '<script>.*?=\[(.*?)\];.*?=\[(.*?)\];for\('
        matches = re.compile(patron,re.DOTALL).findall(cookieval)
        for cKey, cValue in matches:
            #logger.info("[seriespepito.py] Encontrado " + cKey+ '-' + cValue )
            exec 'Keys = [' + cKey + ']'
            exec 'Values = [' + cValue + ']'

            #Ajuste de caracteres :
             #Comparamos los valores resultado de los tres caracter a caracter y si hay dos iguales el tercero se "arregla" poniendo ese valor.
            iCont = 0
            while iCont < len(Values[0]):
                if Values[0][iCont]==Values[1][iCont]:
                   Values[2] = Values[2][:iCont] + Values[1][iCont] + Values[2][iCont+1:]
                elif Values[1][iCont]==Values[2][iCont]:
                   Values[0] = Values[0][:iCont] + Values[1][iCont] + Values[0][iCont+1:] #Values[0][iCont]=Values[1][iCont]
                elif Values[0][iCont]==Values[2][iCont]:
                   Values[1] = Values[1][:iCont] + Values[0][iCont] + Values[1][iCont+1:] #Values[1][iCont]=Values[0][iCont]
                iCont +=1

            Urls.update(dict(zip(Keys, Values)))

    sUrl = "http://www.enlacespepito.com/"+Urls[Cookies[CookieIndex].split(CharSplit)[int(IndexSplit)]]+".html"
    logger.info("[seriespepito.py] Url " + sUrl)

    return sUrl

def get_server_link(first_link, ref, link_type):
    ENLACESPEPITO_REQUEST_HEADERS.append(["Referer",ref])

    #140727 Version sacando las Urls de las Cookies
    cookie = scrapertools.get_header_from_response(first_link, header_to_get="set-cookie", headers = ENLACESPEPITO_REQUEST_HEADERS)

    fixed_link = extract_link_from_cookies(cookie)

    ENLACESPEPITO_REQUEST_HEADERS.append(['Referer', first_link])
    sUrl = scrapertools.get_header_from_response(fixed_link, header_to_get="location", headers = ENLACESPEPITO_REQUEST_HEADERS)

    return sUrl

# Estas funciones son las únicas que deberían llamarse desde fuera
#
def get_server_link_series(first_link, Ref):
    return get_server_link(first_link, Ref, SERIES_PEPITO)

def get_server_link_peliculas(first_link, Ref):
    return get_server_link(first_link, Ref, PELICULAS_PEPITO)

